﻿using ProjectTourismCompany.Entities.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectTourismCompany.Entities;

public class Trip
{
    public int Id { get; private set; }
    public string Title { get; private set; } = string.Empty;
    public int Price {  get; private set; }
    public int HumanCapacity {  get; private set; }
    public DateTime StartDate {  get; private set; }
    public DateTime EndDate { get; private set;}
    public string StartCity {  get; private set; }=string.Empty;
    public string EndCity { get; private set;} =string.Empty;
    public TravelType TravelType { get; private set; }

    public IEnumerable<CompanyTrip> CompanyTrip
    {
        get;
        private set;
    } = [];

    public static Trip CreateOpeartion(int id, string title, int price, int humanCapacity, DateTime startDate, DateTime endDate, string startCity, string endCity, TravelType travelType, IEnumerable<CompanyTrip> companyTrip)
    {
        return new Trip
        {
            Title = title,
            Id = id,
            Price = price,
            HumanCapacity = humanCapacity,
            StartDate = startDate,
            EndDate = endDate,
            StartCity = startCity,
            EndCity = endCity,
            TravelType = travelType,
            CompanyTrip = companyTrip
        };
    }



    public static Trip CreateOpeartion(TempCompanyTrip tempCompanyTrip,IEnumerable<CompanyTrip> companyTrip)
    {
        return new Trip
        {
            Title = tempCompanyTrip.Title,
            Id = tempCompanyTrip.Id,
            Price = tempCompanyTrip.Price,
            HumanCapacity=tempCompanyTrip.HumanCapacity,
            StartDate = tempCompanyTrip.StartDate,
            EndDate = tempCompanyTrip.EndDate,
            StartCity = tempCompanyTrip.StartCity,
            EndCity = tempCompanyTrip.EndCity,
            TravelType = tempCompanyTrip.TravelType,
            CompanyTrip = companyTrip

        };
    }
}
